#include <Wire.h>
#include <EEPROM.h> //Needed to record user settings
#include <LiquidCrystal_I2C.h>

#include "SparkFun_Qwiic_Scale_NAU7802_Arduino_Library.h" // Click here to get the library: http://librarymanager/All#SparkFun_NAU8702

LiquidCrystal_I2C lcd(0x27,16,2);
NAU7802 myScale; //Create instance of the NAU7802 class

//servo
#include <Servo.h>
Servo servo1;

static const int servoPin = 27;
const int pumpOn = 180;
const int pumpOff = 90;

//EEPROM locations to store 4-byte variables
#define LOCATION_CALIBRATION_FACTOR 0 //Float, requires 4 bytes of EEPROM
#define LOCATION_ZERO_OFFSET 10 //Must be more than 4 away from previous spot. Long, requires 4 bytes of EEPROM
bool settingsDetected = false; //Used to prompt user to calibrate their scale
//Create an array to take average of weights. This helps smooth out jitter.
#define AVG_SIZE 4
float avgWeights[AVG_SIZE];
byte avgWeightSpot = 0;

float avgWeight;
int i=0;

// tombol
const byte commonPin = 23;
const int analogPin = 34;

int analogVal = 0;


long debouncing_time = 100; //Debouncing Time in Milliseconds
volatile unsigned long last_micros;

volatile int pressedBut =0 ; //0 berati tidak ada yang dipencet, brew=1, up = 2, down = 3, select = 4 

int pages =0; // manual =0, coffe 1=1, coffee 2=2, coffee 3 = 3, calibration = 4

////////////////////////////////
//time
unsigned long time1 = 0;

float waktu = 0;

float weightTarget[3] = {30.0, 30.0, 30.0};

void setup() {
 pinMode(commonPin, INPUT);
 attachInterrupt(digitalPinToInterrupt(commonPin), butfun1, FALLING);
 servo1.attach(servoPin);

   lcd.init();
  lcd.backlight();
  lcd.setCursor(0,0);lcd.print("hello");
  delay(2000);lcd.clear();

  Wire.begin();
  Wire.setClock(400000); //Qwiic Scale is capable of running at 400kHz if desired

  if (myScale.begin() == false)
  {
    //Serial.println("Scale not detected. Please check wiring. Freezing...");
    while (1);
  }
  //Serial.println("Scale detected!");

  readSystemSettings(); //Load zeroOffset and calibrationFactor from EEPROM

  myScale.setSampleRate(NAU7802_SPS_320); //Increase to max sample rate
  myScale.calibrateAFE(); //Re-cal analog front end when we change gain, sample rate, or channel
  
  
  delay(1000);
  

}

void loop() {
  while (pages==0){manual();}
  while (pages>0&&pages<4){brewWithTarget(pages);}
  while(pages==4){calibrateScale();}
  
}




void butfun1(){
  if((long)(micros() - last_micros) >= debouncing_time * 5000){
    last_micros = micros();
    analogVal = analogRead(analogPin);

    if(analogVal >=1500){ //brew
      pressedBut=1;
    }else if (analogVal==0){  //up
      pressedBut=2;
    }else if(analogVal>800&&analogVal<1000){ // down
      pressedBut=3;
    }else if (analogVal>300 && analogVal<500){ //select
      pressedBut=4;
    }

  }
}

void manual(){
  lcd.setCursor(0,0);
  lcd.print("Manual");
  if (pressedBut == 1){ // brew start
    pressedBut=0;
    myScale.calculateZeroOffset(); // tare
    delay(500);
    float rs=readingScale();
    servo1.write(pumpOn); delay(3); // pump on
    waktu=0;
    time1=millis();
    
    while (pressedBut!=1){
    if (millis() >= time1 + 100){
      time1+= 100;  
      lcd.setCursor(8,1); lcd.print(" t:"); lcd.print(waktu, 1); lcd.print("s");
      waktu=waktu+0.1;
      }
    rs=readingScale();
    lcd.setCursor(0,1); lcd.print("w:"); lcd.print(rs); lcd.print("g");
    
    }
    servo1.write(pumpOff);delay(3); //pump stops
    pressedBut=0;
    lcd.clear();
    lcd.setCursor(0,0); lcd.print("Stopped");
    delay(500);
    rs=readingScale();
    lcd.setCursor(0,1); lcd.print("w:"); lcd.print(rs); lcd.print("g");
    lcd.setCursor(8,1);lcd.print(" t:"); lcd.print(waktu, 1); lcd.print("s");
    delay (5000);
    lcd.clear();
  }else if (pressedBut == 2){
    pages=4;
    pressedBut = 0;
    lcd.clear();
  }else if (pressedBut == 3){
    pages++;
    pressedBut = 0;
    lcd.clear();
  }else if (pressedBut == 4){ // nothing happens
    pages=0;
    pressedBut = 0;
  }
    
}

void brewWithTarget(int i){
  lcd.setCursor(0,0);
  lcd.print("Coffee "); lcd.print(i);
  lcd.setCursor(0, 1); lcd.print(weightTarget[i-1]); lcd.print(" g");
  if (pressedBut==1){ // brew with the target
    pressedBut=0;
    lcd.clear();lcd.setCursor(0,0);lcd.print("target :  "); lcd.print(weightTarget[i-1]); lcd.print(" g");
    float rs = 0;
    myScale.calculateZeroOffset(); // tare
    delay(500);
    rs = readingScale();
    servo1.write(pumpOn); delay(3);// pump starts
    waktu=0;
    time1=millis();
    while (pressedBut!=1 && rs <= weightTarget[i-1]-2 ){ // selama brew button tidak di tekan dan weight tidak terpenuhi maka tetap brewing
    if (millis() >= time1 + 100){
      time1+= 100;  
      lcd.setCursor(8,1); lcd.print(" t:"); lcd.print(waktu, 1); lcd.print("s");
      waktu=waktu+0.1;
      }
    rs=readingScale();
    lcd.setCursor(0,1); lcd.print("w:"); lcd.print(rs); lcd.print("g");
    
    }
    servo1.write(pumpOff); delay(3);//pump stops
    
    pressedBut=0;
    lcd.clear();
    lcd.setCursor(0,0); lcd.print("Stopped");
    delay(1000);
    rs = readingScale();
    lcd.setCursor(0,1); lcd.print("w : "); lcd.print(rs); lcd.print(" g");
    lcd.setCursor(7,1); lcd.print("t : "); lcd.print(waktu, 1); lcd.print(" s");
    delay (5000);
    lcd.clear();
    
  }else if(pressedBut==4){  // setup target berat
    pressedBut=0;
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Coffee "); lcd.print(i); lcd.print(" *");
    while(pressedBut!=4){
    lcd.setCursor(0,1); lcd.print(weightTarget[i-1]); lcd.print(" g");
    if (pressedBut==2){
      pressedBut=0;
      weightTarget[i-1]+=0.5;
      lcd.clear();
      lcd.print("Coffee "); lcd.print(i); lcd.print(" *");
    }else  if (pressedBut==3){
      pressedBut=0;
      weightTarget[i-1]-=0.5;
      lcd.clear();
      lcd.print("Coffee "); lcd.print(i); lcd.print(" *");
     }else if(pressedBut==1){pressedBut=0;} //nothing happens
    
   }
   pressedBut=0;
   lcd.clear();
 }else if (pressedBut == 2){
    pages--;
    pressedBut = 0;
    lcd.clear();
  }else if (pressedBut == 3){
    pages+=1;
    pressedBut = 0;
    lcd.clear();
  }
 
}

void calibrateScale(void)
{
  lcd.setCursor(0,0); lcd.print("Calibrate");
  if (pressedBut==4){
    lcd.clear(); lcd.setCursor(0,0); lcd.print("place no weight");lcd.setCursor(0,1);lcd.print("and press select");
    pressedBut=0;
    delay(500);
    while(pressedBut==0){} // waiting select to be pressed
     pressedBut=0;
     
    myScale.calculateZeroOffset(64); //Zero or Tare the scale. Average over 64 readings.
    lcd.clear();lcd.setCursor(0,0); lcd.print("new Offset : ");lcd.setCursor(0,1);lcd.print(myScale.getZeroOffset());
    delay(1000);
    lcd.clear();lcd.setCursor(0,0);lcd.print("place 500g");lcd.setCursor(0,1); lcd.print("and press select");
    while (pressedBut==0){} pressedBut=0;// waiting select to be pressed
    lcd.clear();lcd.setCursor(0,0);lcd.print("calibrating...");
    myScale.calculateCalibrationFactor(500, 64); //Tell the library how much weight is currently on it
    delay(1000);
    lcd.clear();lcd.setCursor(0,0);lcd.print("completed");lcd.setCursor(0,1);lcd.print("w : ");lcd.print(myScale.getWeight(), 2);
    recordSystemSettings(); //Commit these values to EEPROM
    delay(3000);
    lcd.clear();
     
   
   }else if (pressedBut == 2){
    pages--;
    pressedBut = 0;
    lcd.clear();
  }else if (pressedBut == 3){ //back to manual page
    pages=0;
    pressedBut = 0;
    lcd.clear();
  }else if (pressedBut == 1){ //nothing happens
    pressedBut = 0;
  }

}

//Record the current system settings to EEPROM
void recordSystemSettings(void)
{
  //Get various values from the library and commit them to NVM
  EEPROM.put(LOCATION_CALIBRATION_FACTOR, myScale.getCalibrationFactor());
  EEPROM.put(LOCATION_ZERO_OFFSET, myScale.getZeroOffset());
}

//Reads the current system settings from EEPROM
//If anything looks weird, reset setting to default value
void readSystemSettings(void)
{
  float settingCalibrationFactor; //Value used to convert the load cell reading to lbs or kg
  long settingZeroOffset; //Zero value that is found when scale is tared

  //Look up the calibration factor
  EEPROM.get(LOCATION_CALIBRATION_FACTOR, settingCalibrationFactor);
  if (settingCalibrationFactor == 0xFFFFFFFF)
  {
    settingCalibrationFactor = 0; //Default to 0
    EEPROM.put(LOCATION_CALIBRATION_FACTOR, settingCalibrationFactor);
  }

  //Look up the zero tare point
  EEPROM.get(LOCATION_ZERO_OFFSET, settingZeroOffset);
  if (settingZeroOffset == 0xFFFFFFFF)
  {
    settingZeroOffset = 1000L; //Default to 1000 so we don't get inf
    EEPROM.put(LOCATION_ZERO_OFFSET, settingZeroOffset);
  }

  //Pass these values to the library
  myScale.setCalibrationFactor(settingCalibrationFactor);
  myScale.setZeroOffset(settingZeroOffset);

  settingsDetected = true; //Assume for the moment that there are good cal values
  if (settingCalibrationFactor < 0.1 || settingZeroOffset == 1000)
    settingsDetected = false; //Defaults detected. Prompt user to cal scale.
}

float readingScale(){
  if (myScale.available() == true)
  {
    long currentReading = myScale.getReading();
    float currentWeight = myScale.getWeight();

    /*Serial.print("Reading: ");
    Serial.print(currentReading);
    Serial.print("\tWeight: ");
    Serial.print(currentWeight, 2); //Print 2 decimal places*/

    avgWeights[avgWeightSpot++] = currentWeight;
    if(avgWeightSpot == AVG_SIZE) avgWeightSpot = 0;

     avgWeight = 0;
    for (int x = 0 ; x < AVG_SIZE ; x++)
      avgWeight += avgWeights[x];
    avgWeight /= AVG_SIZE;

     //Serial.print("\tAvgWeight: ");
     //Serial.print(avgWeight, 2); //Print 2 decimal places

    if(settingsDetected == false)
    {
      lcd.setCursor(1,0);lcd.print("calibrate, pls!");
      delay(100);
    }
  }
  return avgWeight;
}
